# Installation
> `npm install --save @types/cli-spinner`

# Summary
This package contains type definitions for cli-spinner (https://github.com/helloIAmPau/node-spinner).

# Details
Files were exported from https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/cli-spinner.
## [index.d.ts](https://github.com/DefinitelyTyped/DefinitelyTyped/tree/master/types/cli-spinner/index.d.ts)
````ts
/// <reference types="node" />

export interface Options {
    text?: string | undefined;
    stream?: NodeJS.WritableStream | undefined;
    onTick?(this: Spinner, msg: string): void;
}

export class Spinner {
    static setDefaultSpinnerString(spinnerString: string | number): typeof Spinner;
    static setDefaultSpinnerDelay(spinnerDelay: number): typeof Spinner;

    readonly stream: NodeJS.WritableStream;

    constructor(titleOrOptions?: string | Options);

    start(): this;
    stop(clear?: boolean): this;
    isSpinning(): boolean;
    clearLine(stream: NodeJS.WritableStream): this;
    setSpinnerString(spinnerString: string | number): this;
    setSpinnerTitle(title: string): this;
    setSpinnerDelay(spinnerDelay: number): this;
}

````

### Additional Details
 * Last updated: Mon, 06 Nov 2023 22:41:05 GMT
 * Dependencies: [@types/node](https://npmjs.com/package/@types/node)

# Credits
These definitions were written by [Jay Anslow](https://github.com/janslow).
