/**
 * Get a list of the data entry IDs, in the order of that list
 *
 * @access public
 * @method getIds
 * @memberof module:@citation-js/core.Cite#
 *
 * @return {Array<String>} List of IDs
 */
export function getIds(): Array<string>;
/**
 * Get formatted data from your object.
 *
 * @access public
 * @method format
 * @memberof module:@citation-js/core.Cite#
 *
 * @param {String} format - format module name
 * @param {...*} options - module options (see relevant documentation)
 *
 * @return {String|Array<Object>} formatted data
 */
export function format(format: string, ...options: any[]): string | Array<any>;
/**
 * Get formatted data from your object.
 *
 * @access public
 * @method get
 * @memberof module:@citation-js/core.Cite#
 * @tutorial output
 * @deprecated use {@link module:@citation-js/core.Cite#format}
 *
 * @param {module:@citation-js/core~OutputOptions} [options={}] - Output options
 *
 * @return {String|Array<Object>} The formatted data
 */
export function get(options?: any): string | Array<any>;
