export default Cite;
/**
 * Create a `Cite` object with almost any kind of data, and manipulate it with its default methods.
 *
 * @access public
 * @constructor Cite
 * @memberof module:@citation-js/core
 *
 * @param {module:@citation-js/core~InputData} data - Input data
 * @param {module:@citation-js/core~InputOptions} [options={}] - Input options
 */
declare function Cite(data: any, options?: any): Cite;
declare class Cite {
    /**
     * Create a `Cite` object with almost any kind of data, and manipulate it with its default methods.
     *
     * @access public
     * @constructor Cite
     * @memberof module:@citation-js/core
     *
     * @param {module:@citation-js/core~InputData} data - Input data
     * @param {module:@citation-js/core~InputOptions} [options={}] - Input options
     */
    constructor(data: any, options?: any);
    /**
     * The default options for the output. See [input options](../#cite.in.options)
     *
     * @access protected
     * @memberof module:@citation-js/core.Cite#
     *
     * @var {module:@citation-js/core~InputOptions} _options
     */
    _options: any;
    /**
     * The saved-images-log
     *
     * @access protected
     * @memberof module:@citation-js/core.Cite#
     *
     * @var {Array<Array<String>>} log
     */
    log: any[];
    /**
     * The parsed data
     *
     * @access protected
     * @memberof module:@citation-js/core.Cite#
     *
     * @var {Array<module:@citation-js/core~CSL>} data
     */
    data: any[];
}
