const unicode = {
    diacritics: {
        '`': '̀',
        "'": '́',
        '^': '̂',
        '~': '̃',
        '=': '̄',
        u: '̆',
        '.': '̇',
        '"': '̈',
        r: '̊',
        H: '̋',
        v: '̌',
        b: '̲',
        d: '̣',
        c: '̧',
        k: '̨',
        t: '͡',
        textcommabelow: '̦',
    },
    commands: {
        textquotesingle: "'",
        textasciigrave: '`',
        textquotedbl: '"',
        textdollar: '$',
        textless: '<',
        textgreater: '>',
        textbackslash: '\\',
        textasciicircum: '^',
        textunderscore: '_',
        textbraceleft: '{',
        textbar: '|',
        textbraceright: '}',
        textasciitilde: '~',
        textexclamdown: '¡',
        textcent: '¢',
        textsterling: '£',
        textcurrency: '¤',
        textyen: '¥',
        textbrokenbar: '¦',
        textsection: '§',
        textasciidieresis: '¨',
        textcopyright: '©',
        textordfeminine: 'ª',
        guillemetleft: '«',
        guillemotleft: '«',
        textlnot: '¬',
        textregistered: '®',
        textasciimacron: '¯',
        textdegree: '°',
        textpm: '±',
        texttwosuperior: '²',
        textthreesuperior: '³',
        textasciiacute: '´',
        textmu: 'µ',
        textparagraph: '¶',
        textperiodcentered: '·',
        textonesuperior: '¹',
        textordmasculine: 'º',
        guillemetright: '»',
        guillemotright: '»',
        textonequarter: '¼',
        textonehalf: '½',
        textthreequarters: '¾',
        textquestiondown: '¿',
        AE: 'Æ',
        DH: 'Ð',
        texttimes: '×',
        O: 'Ø',
        TH: 'Þ',
        ss: 'ß',
        ae: 'æ',
        dh: 'ð',
        textdiv: '÷',
        o: 'ø',
        th: 'þ',
        DJ: 'Đ',
        dj: 'đ',
        i: 'ı',
        IJ: 'Ĳ',
        ij: 'ĳ',
        L: 'Ł',
        l: 'ł',
        NG: 'Ŋ',
        ng: 'ŋ',
        OE: 'Œ',
        oe: 'œ',
        textflorin: 'ƒ',
        j: 'ȷ',
        textasciicaron: 'ˇ',
        textasciibreve: '˘',
        textacutedbl: '˝',
        textgravedbl: '˵',
        texttildelow: '˷',
        textbaht: '฿',
        SS: 'ẞ',
        textcompwordmark: '‌',
        textendash: '–',
        textemdash: '—',
        textbardbl: '‖',
        textquoteleft: '‘',
        textquoteright: '’',
        quotesinglbase: '‚',
        textquotedblleft: '“',
        textquotedblright: '”',
        quotedblbase: '„',
        textdagger: '†',
        textdaggerdbl: '‡',
        textbullet: '•',
        textellipsis: '…',
        textperthousand: '‰',
        textpertenthousand: '‱',
        guilsinglleft: '‹',
        guilsinglright: '›',
        textreferencemark: '※',
        textinterrobang: '‽',
        textfractionsolidus: '⁄',
        textlquill: '⁅',
        textrquill: '⁆',
        textdiscount: '⁒',
        textcolonmonetary: '₡',
        textlira: '₤',
        textnaira: '₦',
        textwon: '₩',
        textdong: '₫',
        texteuro: '€',
        textpeso: '₱',
        textcelsius: '℃',
        textnumero: '№',
        textcircledP: '℗',
        textrecipe: '℞',
        textservicemark: '℠',
        texttrademark: '™',
        textohm: 'Ω',
        textmho: '℧',
        textestimated: '℮',
        textleftarrow: '←',
        textuparrow: '↑',
        textrightarrow: '→',
        textdownarrow: '↓',
        textminus: '−',
        Hwithstroke: 'Ħ',
        hwithstroke: 'ħ',
        textasteriskcentered: '∗',
        textsurd: '√',
        textlangle: '〈',
        textrangle: '〉',
        textblank: '␢',
        textvisiblespace: '␣',
        textopenbullet: '◦',
        textbigcircle: '◯',
        textmusicalnote: '♪',
        textmarried: '⚭',
        textdivorced: '⚮',
        textinterrobangdown: '⸘',
        textcommabelow: null,
        copyright: '©',
        Gamma: 'Γ',
        Delta: 'Δ',
        Theta: 'Θ',
        Lambda: 'Λ',
        Xi: 'Ξ',
        Pi: 'Π',
        Sigma: 'Σ',
        Phi: 'Φ',
        Psi: 'Ψ',
        Omega: 'Ω',
        alpha: 'α',
        beta: 'β',
        gamma: 'γ',
        delta: 'δ',
        varepsilon: 'ε',
        zeta: 'ζ',
        eta: 'η',
        theta: 'θ',
        iota: 'ι',
        kappa: 'κ',
        lambda: 'λ',
        mu: 'μ',
        nu: 'ν',
        xi: 'ξ',
        pi: 'π',
        rho: 'ρ',
        varsigma: 'ς',
        sigma: 'σ',
        tau: 'τ',
        upsilon: 'υ',
        varphi: 'φ',
        chi: 'χ',
        psi: 'ψ',
        omega: 'ω',
        vartheta: 'ϑ',
        Upsilon: 'ϒ',
        phi: 'ϕ',
        varpi: 'ϖ',
        varrho: 'ϱ',
        epsilon: 'ϵ',
    },
};
export default unicode;
